package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class Nonempty_AspectLanguage_List {
  protected AspectLanguage it;
  public AspectLanguage get_it() { return it; }
  public void set_it(AspectLanguage new_it) { it = new_it; }
  protected Nonempty_AspectLanguage_List next;
  public Nonempty_AspectLanguage_List get_next() { return next; }
  public void set_next(Nonempty_AspectLanguage_List new_next) { next = new_next; }
  public Nonempty_AspectLanguage_List() { super(); }
  public Nonempty_AspectLanguage_List(AspectLanguage it, Nonempty_AspectLanguage_List next) {
    super();
    set_it(it);
    set_next(next);
  }
  public static Nonempty_AspectLanguage_List parse(java.io.Reader in) throws ParseException { return new Parser(in)._Nonempty_AspectLanguage_List(); }
  public static Nonempty_AspectLanguage_List parse(java.io.InputStream in) throws ParseException { return new Parser(in)._Nonempty_AspectLanguage_List(); }
  public static Nonempty_AspectLanguage_List parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_it(this, it);
    it.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_it(this, it);
    if (next != null) {
      ((UniversalVisitor) _v_).before_next(this, next);
      next.universal_trv0(_v_);
      ((UniversalVisitor) _v_).after_next(this, next);
    }
    universal_trv0_aft(_v_);
  }

}
